modules/meeting/config/routes.rb
# frozen_string_literal: true

#-- copyright
# OpenProject is an open source project management software.
# Copyright (C) the OpenProject GmbH
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License version 3.
#
# OpenProject is a fork of ChiliProject, which is a fork of Redmine. The copyright follows:
# Copyright (C) 2006-2013 Jean-Philippe Lang
# Copyright (C) 2010-2013 the ChiliProject Team
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
# See COPYRIGHT and LICENSE files for more details.
#++

Rails.application.routes.draw do
  resources :projects, only: %i[] do
    resources :meetings do
      collection do
        get :new_dialog
        get "menu" => "meetings/menus#show"
      end

      member do
        get :copy
        get :check_for_updates
        get :cancel_edit
        get :download_ics
        put :update_title
        get :details_dialog
        put :update_details
        get :participants_dialog
        put :update_participants
        put :change_state
        post :notify
        get :history
        get :delete_dialog
      end
    end

    resources :recurring_meetings do
      member do
        get :details_dialog
        get :download_ics
        get :delete_dialog
        get :delete_scheduled_dialog
        post :init
        delete :destroy_scheduled
        post :template_completed
        post :notify
        post :end_series
        get :end_series_dialog
      end
    end
  end

  resources :work_packages, only: %i[] do
    resources :meetings, only: %i[] do
      collection do
        resources :tab, only: %i[index], controller: "work_package_meetings_tab", as: "meetings_tab" do
          get :count, on: :collection
        end
      end
    end
    resources :meeting_agenda_items, only: %i[] do
      collection do
        get :dialog, controller: "work_package_meetings_tab", action: :add_work_package_to_meeting_dialog
        post :create, controller: "work_package_meetings_tab", action: :add_work_package_to_meeting
      end
    end
  end

  resources :recurring_meetings, only: %i[index show new create] do
    collection do
      get :humanize_schedule, controller: "recurring_meetings/schedule", action: :humanize_schedule
    end
  end

  resources :meetings, only: %i[index show new create] do
    collection do
      get :new_dialog
      get "menu" => "meetings/menus#show"
    end

    resources :agenda_items, controller: "meeting_agenda_items" do
      collection do
        get :new, action: :new, as: :new
        get :cancel_new
      end
      member do
        get :cancel_edit
        put :drop
        put :move
        post :move_to_next, action: :move_to_next_meeting
      end
    end
    resources :sections, controller: "meeting_sections" do
      collection do
        get :new, action: :new, as: :new
        get :cancel_new
      end
      member do
        get :cancel_edit
        put :drop
        put :move
      end
    end
    resources :outcomes, controller: "meeting_outcomes" do
      collection do
        get :new, action: :new, as: :new
        get :cancel_new
      end
      member do
        get :cancel_edit
      end
    end

    resource :agenda, controller: "meeting_agendas", only: [:update] do
      member do
        get :history
        get :diff
        put :close
        put :open
        post :preview
      end

      resources :versions, only: [:show],
                           controller: "meeting_agendas"
    end

    resource :contents, controller: "meeting_contents", only: %i[show update] do
      member do
        get :history
        get :diff
      end
    end

    resource :minutes, controller: "meeting_minutes", only: [:update] do
      member do
        get :history
        get :diff
        post :preview
      end

      resources :versions, only: [:show],
                           controller: "meeting_minutes"
    end

    member do
      match "/:tab" => "meetings#show", :constraints => { tab: /(agenda|minutes)/ },
            :via => :get,
            :as => "tab"
    end
  end
end

modules/meeting/app/models/meeting/chronic_duration.rb
# frozen_string_literal: true
#-- copyright
# OpenProject is an open source project management software.
# Copyright (C) the OpenProject GmbH
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License version 3.
#
# OpenProject is a fork of ChiliProject, which is a fork of Redmine. The copyright follows:
# Copyright (C) 2006-2013 Jean-Philippe Lang
# Copyright (C) 2010-2013 the ChiliProject Team
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
# See COPYRIGHT and LICENSE files for more details.
#++

module Meeting::ChronicDuration
  def duration=(value)
    if value.is_a?(String)
      write_attribute(:duration, value.to_hours)
    else
      super
    end
  end

  def formatted_duration
    DurationConverter.output(duration, format: :hours_only)
  end
end

modules/meeting/app/models/queries/meetings.rb
# frozen_string_literal: true
#-- copyright
# OpenProject is an open source project management software.
# Copyright (C) the OpenProject GmbH
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License version 3.
#
# OpenProject is a fork of ChiliProject, which is a fork of Redmine. The copyright follows:
# Copyright (C) 2006-2013 Jean-Philippe Lang
# Copyright (C) 2010-2013 the ChiliProject Team
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
# See COPYRIGHT and LICENSE files for more details.
#++

module Queries::Meetings
  ::Queries::Register.register(MeetingQuery) do
    filter Filters::ProjectFilter
    filter Filters::TimeFilter
    filter Filters::AttendedUserFilter
    filter Filters::InvitedUserFilter
    filter Filters::AuthorFilter
    filter Filters::DatesIntervalFilter
    filter Filters::RecurringFilter

    order Orders::DefaultOrder
  end
end

modules/meeting/app/controllers/concerns/meetings/work_package_meetings_tab_component_streams.rb
# frozen_string_literal: true
#-- copyright
# OpenProject is an open source project management software.
# Copyright (C) the OpenProject GmbH
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License version 3.
#
# OpenProject is a fork of ChiliProject, which is a fork of Redmine. The copyright follows:
# Copyright (C) 2006-2013 Jean-Philippe Lang
# Copyright (C) 2010-2013 the ChiliProject Team
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
# See COPYRIGHT and LICENSE files for more details.
#++

module Meetings
  module WorkPackageMeetingsTabComponentStreams
    extend ActiveSupport::Concern

    included do
      def update_heading_component_via_turbo_stream(work_package: @work_package)
        update_via_turbo_stream(
          component: WorkPackageMeetingsTab::HeadingComponent.new(
            work_package:
          )
        )
      end

      def update_add_to_meeting_form_component_via_turbo_stream(meeting_agenda_item:, work_package: @work_package,
                                                                base_errors: nil)
        update_via_turbo_stream(
          component: WorkPackageMeetingsTab::AddWorkPackageToMeetingFormComponent.new(
            meeting_agenda_item:,
            work_package:,
            base_errors:
          ),
          status: :bad_request
        )
      end

      def update_index_component_via_turbo_stream(direction:, agenda_items_grouped_by_meeting:,
                                                  upcoming_meetings_count:, past_meetings_count:, work_package: @work_package)
        update_via_turbo_stream(
          component: WorkPackageMeetingsTab::IndexComponent.new(
            direction:,
            agenda_items_grouped_by_meeting:,
            upcoming_meetings_count:,
            past_meetings_count:,
            work_package:
          )
        )
      end

      def replace_tab_counter_via_turbo_stream(work_package: @work_package)
        replace_via_turbo_stream(
          component: WorkPackages::Details::UpdateCounterComponent.new(work_package:, menu_name: "meetings")
        )
      end
    end
  end
end

modules/meeting/app/controllers/meetings/menus_controller.rb
# frozen_string_literal: true
# -- copyright
# OpenProject is an open source project management software.
# Copyright (C) the OpenProject GmbH
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License version 3.
#
# OpenProject is a fork of ChiliProject, which is a fork of Redmine. The copyright follows:
# Copyright (C) 2006-2013 Jean-Philippe Lang
# Copyright (C) 2010-2013 the ChiliProject Team
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
# See COPYRIGHT and LICENSE files for more details.
# ++
module Meetings
  class MenusController < ApplicationController
    before_action :load_and_authorize_in_optional_project

    def show
      @submenu_menu_items = ::Meetings::Menu.new(project: @project, params:).menu_items
      @create_btn_options = if @project.present? && User.current.allowed_in_project?(:create_meetings, @project)
                              { href: new_project_meeting_path(@project), module_key: "meeting" }
                            elsif @project.nil? && User.current.allowed_in_any_project?(:create_meetings)
                              { href: new_meeting_path, module_key: "meeting" }
                            end

      render layout: nil
    end
  end
end

modules/meeting/app/helpers/meetings_helper.rb
# frozen_string_literal: true
#-- copyright
# OpenProject is an open source project management software.
# Copyright (C) the OpenProject GmbH
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License version 3.
#
# OpenProject is a fork of ChiliProject, which is a fork of Redmine. The copyright follows:
# Copyright (C) 2006-2013 Jean-Philippe Lang
# Copyright (C) 2010-2013 the ChiliProject Team
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
# See COPYRIGHT and LICENSE files for more details.
#++

module MeetingsHelper
  def format_participant_list(participants)
    if participants.any?
      user_links = participants
        .sort
        .reject { |p| p.user.nil? }
        .map { |p| link_to_user p.user }

      safe_join(user_links, "; ")
    else
      t("placeholders.default")
    end
  end

  def render_meeting_journal(model, journal, options = {})
    return "" if journal.initial?

    journal_content = render_journal_details(journal, :label_updated_time_by, model, options)
    content_tag "div", journal_content, id: "change-#{journal.id}", class: "journal"
  end

  # This renders a journal entry with a header and details
  def render_journal_details(journal, header_label = :label_updated_time_by, _model = nil, options = {})
    header = <<-HTML
      <div class="profile-wrap">
        #{avatar(journal.user)}
      </div>
      <h4>
        <div class="journal-link" style="float:right;">#{link_to "##{journal.anchor}", anchor: "note-#{journal.anchor}"}</div>
        #{authoring journal.created_at, journal.user, label: header_label}
        #{content_tag('a', '', name: "note-#{journal.anchor}")}
      </h4>
    HTML

    if journal.details.any?
      details = content_tag "ul", class: "details journal-attributes" do
        journal.details.filter_map do |detail|
          if d = journal.render_detail(detail, cache: options[:cache])
            content_tag("li", d.html_safe)
          end
        end.join(" ").html_safe
      end
    end

    content_tag("div", "#{header}#{details}".html_safe, id: "change-#{journal.id}", class: "journal")
  end

  def global_meeting_create_context?
    global_new_meeting_action? || global_create_meeting_action?
  end

  def global_new_meeting_action?
    request.path == new_meeting_path
  end

  def global_create_meeting_action?
    request.path == meetings_path && @project.nil?
  end

  def copy_structured_meeting_participants?
    @copy_from.is_a?(StructuredMeeting) && params[:meeting][:copy_participants] == "1"
  end

  def create_participants
    @converted_params[:participants_attributes] = @copy_from.participants.map do |p|
      {
        "attended" => false,
        "invited" => p.invited ? "1" : false,
        "user_id" => p.user_id.to_s
      }
    end
  end

  def force_defaults
    @converted_params[:participants_attributes].each { |p| p.reverse_merge! attended: false, invited: false }
  end

  def copy_param(key)
    params[key.to_sym] == "1" || params.dig(:meeting, key.to_sym) == "1"
  end
end

modules/meeting/app/views/meetings/_form.html.erb
<%#-- copyright
OpenProject is an open source project management software.
Copyright (C) the OpenProject GmbH

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License version 3.

OpenProject is a fork of ChiliProject, which is a fork of Redmine. The copyright follows:
Copyright (C) 2006-2013 Jean-Philippe Lang
Copyright (C) 2010-2013 the ChiliProject Team

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

See COPYRIGHT and LICENSE files for more details.

++#%>

<%= error_messages_for "meeting" %>

<section class="form--section">

  <div class="form--field -required">
    <%= f.text_field :title, required: true, size: 60, container_class: "-wide" %>
  </div>

  <% copy_from = local_assigns[:copy_from] %>
  <% if copy_from.present? %>
    <%= f.hidden_field :type, value: copy_from.type %>
    <%= hidden_field_tag "copied_from_meeting_id", copy_from.id %>
    <div class="form--field">
      <%= styled_label_tag "copy_agenda", t("meeting.copy.agenda") %>
      <div class="form--field-container">
        <%= styled_check_box_tag "copy_agenda",
                                 1,
                                 true,
                                 no_label: true,
                                 class: "radio-button" %>
      </div>
      <div class="form--field-instructions">
        <%= t("meeting.copy.agenda_text") %>
      </div>
    </div>
    <div class="form--field">
      <%= styled_label_tag "copy_attachments", t("meeting.copy.attachments") %>
      <div class="form--field-container">
        <%= styled_check_box_tag "copy_attachments",
                                 1,
                                 false,
                                 no_label: true,
                                 class: "radio-button" %>
      </div>
      <div class="form--field-instructions">
        <%= t("meeting.copy.attachments_text") %>
      </div>
    </div>
  <% elsif @meeting.new_record? %>
    <%= f.hidden_field :type, value: "Meeting" %>
  <% end %>

  <% if global_meeting_create_context? %>
    <div class="form--field -required">
      <label class="form--label" for="project_id"><%= Meeting.human_attribute_name(:project) %>:</label>
      <div class="form--field-container">
        <%= angular_component_tag "opce-project-autocompleter",
                                  inputs: {
                                    filters: [{ name: "user_action", operator: "=", values: ["meetings/create"] }],
                                    inputName: "project_id",
                                    inputValue: @project&.id,
                                    appendTo: "body",
                                    hiddenFieldAction: "change->refresh-on-form-changes#triggerTurboStream"
                                  },
                                  id: "project_id",
                                  class: "form--select-container -wide remote-field--input",
                                  data: {
                                    "test-selector": "project_id"
                                  } %>
      </div>
    </div>
  <% end %>

  <div class="form--field">
    <%= f.text_field :location, size: 60, container_class: "-wide" %>
  </div>

  <div class="form--field -required">
    <label for="meeting_start_date" class="form--label"><%= Meeting.human_attribute_name(:start_date) %>
      <span class="hidden-for-sighted">
        <%= t(:label_start_date) %><%= t(:text_hint_date_format) %>
      </span>
    </label>

    <div class="form--field-container -visible-overflow">
      <%= f.date_picker :start_date,
                        id: "meeting-form-start-date",
                        required: true,
                        no_label: true %>
      <label for="meeting-form-start-time" class="hidden-for-sighted">
        <%= Meeting.human_attribute_name(:start_time) %>
        <label lang="en">
          <%= t(:label_time_zone) %>
          <%= formatted_time_zone_offset %>
        </label>
      </label>
      <%= f.text_field :start_time_hour,
                       id: "meeting-form-start-time",
                       required: true,
                       type: "time",
                       no_label: true,
                       step: 5.minutes,
                       suffix: formatted_time_zone_offset,
                       container_class: "-xslim" %>
    </div>
  </div>

  <div class="form--field -required">
    <label for="meeting-form-duration" class="form--label"><%= Meeting.human_attribute_name(:duration) %></label>
    <div class="form--field-container">
      <%= f.number_field :duration,
                         id: "meeting-form-duration",
                         required: true,
                         size: 5,
                         no_label: true,
                         min: 0.00,
                         step: 0.25,
                         max: 168,
                         suffix: t(:text_in_hours),
                         container_class: "-xslim" %>
    </div>
  </div>

  <%= render partial: "meetings/participants_section" %>

  <div class="form--field">
    <%= styled_label_tag "send_notfications", t(:"meeting.email.send_emails") %>
    <div class="form--field-container">
      <%= styled_check_box_tag "send_notifications",
                               1,
                               false %>
    </div>
    <div class="form--field-instructions">
      <%= t(:"meeting.email.send_invitation_emails") %>
    </div>
  </div>
</section>

modules/meeting/app/views/meetings/_grouped_meetings.html.erb
<%#-- copyright
OpenProject is an open source project management software.
Copyright (C) the OpenProject GmbH

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License version 3.

OpenProject is a fork of ChiliProject, which is a fork of Redmine. The copyright follows:
Copyright (C) 2006-2013 Jean-Philippe Lang
Copyright (C) 2010-2013 the ChiliProject Team

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

See COPYRIGHT and LICENSE files for more details.

++#%>

<% if @grouped_meetings.empty? || @grouped_meetings.values.all?(&:empty?) -%>
  <%= render Meetings::TableComponent.new(
        rows: [],
        current_project: @project
      ) %>
<% end %>
<% %i[today tomorrow this_week later].each_with_index do |key, i| %>
  <% group = @grouped_meetings[key] %>
  <% if group.present? %>
    <%= render(Primer::OpenProject::Heading.new(
                 tag: :h3,
                 mb: 3,
                 mt: i == 0 ? 0 : 3
               )) { I18n.t("label_meeting_index_#{key}") } %>
    <%= render Meetings::TableComponent.new(
          rows: group,
          current_project: @project,
          test_selector: "meetings-table-#{key}"
        ) %>
  <% end %>
<% end %>

modules/meeting/app/views/meetings/details_dialog.turbo_stream.erb
<%=
  turbo_stream.dialog do
    render(Meetings::SidePanel::DetailsDialogComponent.new(meeting: @meeting))
  end
%>

modules/meeting/app/views/meetings/history.html.erb
<%= content_tag(
      "turbo-frame",
      id: "meetings-history-dialog-frame",
      class: "Overlay-form",
      data: { "op-turbo-op-primer-async-dialog-target": "frameElement" }
    ) do
      render(Primer::Alpha::Dialog::Body.new) do
        render(Activities::DaysComponent.new(events: @events, current_project: @project, activity_page: @activity_page))
      end
    end %>

modules/meeting/app/views/meetings/history.turbo_stream.erb
<%=
  turbo_stream.dialog do
    render(
      Primer::Alpha::Dialog.new(
        title: t(:label_history),
        size: :xlarge,
        id: "meeting-history-dialog"
      )
    ) do |d|
      d.with_header(variant: :large)
      d.with_body do
        render(Activities::DaysComponent.new(events: @events, current_project: @project, activity_page: @activity_page))
      end
    end
  end
%>

modules/meeting/app/views/meetings/participants_dialog.turbo_stream.erb
<%=
  turbo_stream.dialog do
    render(Meetings::SidePanel::ParticipantsDialog.new(meeting: @meeting))
  end
%>

modules/meeting/app/views/meetings/show.html.erb
<%#-- copyright
OpenProject is an open source project management software.
Copyright (C) the OpenProject GmbH

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License version 3.

OpenProject is a fork of ChiliProject, which is a fork of Redmine. The copyright follows:
Copyright (C) 2006-2013 Jean-Philippe Lang
Copyright (C) 2010-2013 the ChiliProject Team

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

See COPYRIGHT and LICENSE files for more details.

++#%>

<%= toolbar title: t(:label_meeting),
            link_to: link_to(@meeting),
            html: { class: "meeting--main-toolbar -with-dropdown" } do %>
  <% unless User.current.anonymous? %>
    <li class="toolbar-item hidden-for-tablet">
      <div class="button">
        <%= watcher_link @meeting, User.current %>
      </div>
    </li>
  <% end %>
  <% if authorize_for(:meetings, :edit) %>
    <li class="toolbar-item">
      <%= link_to(edit_project_meeting_path(@project, @meeting), class: "button", accesskey: accesskey(:edit)) do %>
        <%= op_icon("button--icon icon-edit") %>
        <span class="button--text"><%= t(:button_edit) %></span>
      <% end %>
    </li>
  <% end %>

  <li class="toolbar-item drop-down">
    <a
      href="#"
      aria-haspopup="true"
      title="<%= t(:label_more) %>"
      class="button"
      data-test-selector="meetings-more-dropdown-menu">
      <%= op_icon("button--icon icon-show-more") %>
    </a>
    <ul style="display:none;" class="menu-drop-down-container">
      <% if authorize_for(:meetings, :notify) %>
        <li>
          <%= link_to t("meeting.label_mail_all_participants"),
                      notify_project_meeting_path(@project, @meeting),
                      class: "icon-context icon-mail1",
                      method: :post %>
        </li>
      <% end %>
      <% if authorize_for(:meetings, :icalendar) %>
        <li>
          <%= link_to t(:label_icalendar_download),
                      download_ics_project_meeting_path(@project, @meeting),
                      class: "icon-context icon-calendar2" %>
        </li>
      <% end %>
      <% if authorize_for(:meetings, :copy) %>
        <li>
          <%= link_to(
                t(:button_copy),
                copy_project_meeting_path(@project, @meeting),
                class: "icon-context icon-copy"
              ) %>
        </li>
      <% end %>
      <% if authorize_for(:meetings, :destroy) %>
        <li>
          <%= link_to(
                t(:button_delete),
                project_meeting_path(@project, @meeting),
                class: "icon-context icon-delete",
                method: :delete,
                data: { confirm: t(:text_are_you_sure) }
              ) %>
        </li>
      <% end %>
    </ul>
  </li>
<% end %>

<div class="meeting details box">
  <div class="grid-block wrap">
    <div class="grid-content small-12 block--author">
      <%= avatar(@meeting.author) %>
      <p class="author"><%= authoring @meeting.created_at, @meeting.author %></p>
    </div>
    <div class="grid-content small-6">
      <p>
        <strong><%= Meeting.human_attribute_name(:start_time) %></strong>: <%= format_date @meeting.start_time %> <%= format_time @meeting.start_time, include_date: false %>
        - <%= format_time @meeting.end_time, include_date: false %> <%= formatted_time_zone_offset %></p>
    </div>
    <div class="grid-content small-6">
      <p>
        <strong><%= Meeting.human_attribute_name(:location) %></strong>: <%= auto_link(h(@meeting.location), link: :all, html: { target: "_blank" }) %>
      </p>
    </div>
    <div class="grid-content small-12">
      <p>
        <strong><%= Meeting.human_attribute_name(:participants_invited) %></strong>: <%= format_participant_list @meeting.participants.invited %>
      </p>
    </div>
    <div class="grid-content small-12">
      <p>
        <strong><%= Meeting.human_attribute_name(:participants_attended) %></strong>: <%= format_participant_list @meeting.participants.attended %>
      </p>
    </div>
  </div>
</div>

<%= render_tabs(
      [
        { name: "agenda",
          action: :create_meeting_agendas,
          partial: "meeting_contents/show",
          path: meeting_agenda_path(@meeting),
          label: :label_meeting_agenda,
          content: @meeting.agenda || @meeting.build_agenda,
          content_type: "meeting_agenda" },
        {
          name: "minutes",
          action: :create_meeting_minutes,
          partial: "meeting_contents/show",
          path: meeting_minutes_path(@meeting),
          label: :label_meeting_minutes, content: @meeting.minutes || @meeting.build_minutes,
          content_type: "meeting_minutes"
        }
      ]
    ) %>

<% if @meeting.journals.changing.present? %>
  <div id="history">
    <h3><%= t(:label_history) %></h3>
    <% @meeting.journals.each do |journal| %>
      <%= render_meeting_journal @meeting, journal %>
    <% end %>
  </div>
<% end %>